RDKit: RDKit::FilterCatalog Class Reference

| RDKit Open-source cheminformatics and machine learning.

Loading...
Searching...
No Matches
Public Types | Public Member Functions | List of all members
RDKit::FilterCatalog Class Reference

`#include <FilterCatalog.h>`

Inheritance diagram for RDKit::FilterCatalog:

## Public Types
typedef boost::shared_ptr< FilterCatalogEntry > | SENTRY
typedef boost::shared_ptr< const entryType_t > | CONST_SENTRY
Public Types inherited from RDCatalog::Catalog< FilterCatalogEntry, FilterCatalogParams >
typedef FilterCatalogEntry | entryType_t
typedef FilterCatalogParams | paramType_t
typedef FilterCatalogEntry | entryType_t
typedef FilterCatalogParams | paramType_t

## Public Member Functions
| FilterCatalog ()
| FilterCatalog (FilterCatalogParams::FilterCatalogs catalogs)
| FilterCatalog (const FilterCatalogParams &params)
| FilterCatalog (const FilterCatalog &rhs)
| FilterCatalog (const std::string &binStr)
| ~FilterCatalog () override
std::string | Serialize () const override
| return a serialized form of the Catalog as an std::string
unsigned int | addEntry (FilterCatalogEntry *entry, bool updateFPLength=true) override
virtual unsigned int | addEntry (SENTRY entry, bool updateFPLength=true)
bool | removeEntry (unsigned int idx)
bool | removeEntry (CONST_SENTRY entry)
const FilterCatalogEntry * | getEntryWithIdx (unsigned int idx) const override
CONST_SENTRY | getEntry (unsigned int idx) const
unsigned int | getIdxForEntry (const FilterCatalogEntry *entry) const
| returns the idx of the given entry, UINT_MAX if not found.
unsigned int | getIdxForEntry (CONST_SENTRY entry) const
unsigned int | getNumEntries () const override
| returns the number of entries in the catalog
void | setCatalogParams (const FilterCatalogParams *params) override
| Reset the current catalog to match the specified FilterCatalogParameters.
bool | hasMatch (const ROMol &mol) const
| Returns true if the molecule matches any entry in the catalog.
CONST_SENTRY | getFirstMatch (const ROMol &mol) const
| Returns the first match against the catalog.
const std::vector< CONST_SENTRY > | getMatches (const ROMol &mol) const
| Returns all entry matches to the molecule.
const std::vector< FilterMatch > | getFilterMatches (const ROMol &mol) const
| Returns all FilterMatches for the molecule.
Public Member Functions inherited from RDCatalog::Catalog< FilterCatalogEntry, FilterCatalogParams >
| Catalog ()
virtual | ~Catalog ()
virtual unsigned int | addEntry (FilterCatalogEntry *entry, bool updateFPLength=true)=0
| adds an entry to the catalog
unsigned int | getFPLength () const
| returns the length of our fingerprint
void | setFPLength (unsigned int val)
| sets our fingerprint length
virtual void | setCatalogParams (const FilterCatalogParams *params)
| sets our parameters by copying the `params` argument
const FilterCatalogParams * | getCatalogParams () const
| returns a pointer to our parameters
| Catalog ()
virtual | ~Catalog ()
virtual unsigned int | addEntry (FilterCatalogEntry *entry, bool updateFPLength=true)=0
| adds an entry to the catalog
unsigned int | getFPLength () const
| returns the length of our fingerprint
void | setFPLength (unsigned int val)
| sets our fingerprint length
virtual void | setCatalogParams (const FilterCatalogParams *params)
| sets our parameters by copying the `params` argument
const FilterCatalogParams * | getCatalogParams () const
| returns a pointer to our parameters

## Additional Inherited Members
Protected Attributes inherited from RDCatalog::Catalog< FilterCatalogEntry, FilterCatalogParams >
unsigned int | d_fpLength
| the length of our fingerprint
FilterCatalogParams * | dp_cParams
| our params object
unsigned int | d_fpLength
| the length of our fingerprint
FilterCatalogParams * | dp_cParams
| our params object

## Detailed Description

Definition at line 122 of file FilterCatalog.h.

## Member Typedef Documentation

## ◆ CONST_SENTRY

typedef boost::shared_ptr<const entryType_t> RDKit::FilterCatalog::CONST_SENTRY

Definition at line 129 of file FilterCatalog.h.

## ◆ SENTRY

typedef boost::shared_ptr<FilterCatalogEntry> RDKit::FilterCatalog::SENTRY

Definition at line 125 of file FilterCatalog.h.

## Constructor & Destructor Documentation

## ◆ FilterCatalog() [1/5]

RDKit::FilterCatalog::FilterCatalog | ( |  | ) |
| inline

Definition at line 131 of file FilterCatalog.h.

Referenced by FilterCatalog().

## ◆ FilterCatalog() [2/5]

RDKit::FilterCatalog::FilterCatalog | ( | FilterCatalogParams::FilterCatalogs | catalogs | ) |
| inline

Definition at line 133 of file FilterCatalog.h.

References setCatalogParams().

## ◆ FilterCatalog() [3/5]

RDKit::FilterCatalog::FilterCatalog | ( | const FilterCatalogParams & | params | ) |
| inline

Definition at line 139 of file FilterCatalog.h.

References setCatalogParams().

## ◆ FilterCatalog() [4/5]

RDKit::FilterCatalog::FilterCatalog | ( | const FilterCatalog & | rhs | ) |
| inline

Definition at line 143 of file FilterCatalog.h.

References FilterCatalog().

## ◆ FilterCatalog() [5/5]

RDKit::FilterCatalog::FilterCatalog | ( | const std::string & | binStr | ) |

## ◆ ~FilterCatalog()

RDKit::FilterCatalog::~FilterCatalog | ( |  | ) |
| override

## Member Function Documentation

## ◆ addEntry() [1/2]

unsigned int RDKit::FilterCatalog::addEntry | ( | FilterCatalogEntry * | entry,
|  | bool | updateFPLength = true )
| override

Adds a new FilterCatalogEntry to the catalog The catalog owns the entry

Parameters

  entry | The FilterCatalogEntry to add.
  updateFPLength | unused in the FilterCatalog object.

## ◆ addEntry() [2/2]

virtual unsigned int RDKit::FilterCatalog::addEntry | ( | SENTRY | entry,
|  | bool | updateFPLength = true )
| virtual

Adds a new FilterCatalogEntry to the catalog The catalog owns the entry

Parameters

  entry | The shared_ptr of the FilterCatalogEntry to add.
  updateFPLength | unused in the FilterCatalog object.

## ◆ getEntry()

CONST_SENTRY RDKit::FilterCatalog::getEntry | ( | unsigned int | idx | ) | const

returns a particular FilterCatalogEntry in the Catalog memory safe version of getEntryWithIdx

## ◆ getEntryWithIdx()

const FilterCatalogEntry * RDKit::FilterCatalog::getEntryWithIdx | ( | unsigned int | idx | ) | const
| overridevirtual

returns a particular FilterCatalogEntry in the Catalog required by Catalog.h API

Implements RDCatalog::Catalog< FilterCatalogEntry, FilterCatalogParams >.

## ◆ getFilterMatches()

const std::vector< FilterMatch > RDKit::FilterCatalog::getFilterMatches | ( | const ROMol & | mol | ) | const

Returns all FilterMatches for the molecule.

## ◆ getFirstMatch()

CONST_SENTRY RDKit::FilterCatalog::getFirstMatch | ( | const ROMol & | mol | ) | const

Returns the first match against the catalog.

## ◆ getIdxForEntry() [1/2]

unsigned int RDKit::FilterCatalog::getIdxForEntry | ( | const FilterCatalogEntry * | entry | ) | const

returns the idx of the given entry, UINT_MAX if not found.

## ◆ getIdxForEntry() [2/2]

unsigned int RDKit::FilterCatalog::getIdxForEntry | ( | CONST_SENTRY | entry | ) | const

## ◆ getMatches()

const std::vector< CONST_SENTRY > RDKit::FilterCatalog::getMatches | ( | const ROMol & | mol | ) | const

Returns all entry matches to the molecule.

## ◆ getNumEntries()

unsigned int RDKit::FilterCatalog::getNumEntries | ( |  | ) | const
| inlineoverridevirtual

returns the number of entries in the catalog

Implements RDCatalog::Catalog< FilterCatalogEntry, FilterCatalogParams >.

Definition at line 205 of file FilterCatalog.h.

## ◆ hasMatch()

bool RDKit::FilterCatalog::hasMatch | ( | const ROMol & | mol | ) | const

Returns true if the molecule matches any entry in the catalog.

## ◆ removeEntry() [1/2]

bool RDKit::FilterCatalog::removeEntry | ( | CONST_SENTRY | entry | ) |

## ◆ removeEntry() [2/2]

bool RDKit::FilterCatalog::removeEntry | ( | unsigned int | idx | ) |

Removes a FilterCatalogEntry from the catalog.

Parameters

  idx | The FilterCatalogEntry index for the entry to remove. n.b. removing an entry may change the indices of other entries. To safely remove entries, remove entries with the highest idx first.

## ◆ Serialize()

std::string RDKit::FilterCatalog::Serialize | ( |  | ) | const
| overridevirtual

return a serialized form of the Catalog as an std::string

Implements RDCatalog::Catalog< FilterCatalogEntry, FilterCatalogParams >.

## ◆ setCatalogParams()

void RDKit::FilterCatalog::setCatalogParams | ( | const FilterCatalogParams * | params | ) |
| override

Reset the current catalog to match the specified FilterCatalogParameters.

Referenced by FilterCatalog(), and FilterCatalog().

The documentation for this class was generated from the following file:

- FilterCatalog.h